#pragma once

#include <JUI/Widgets/Rect.hpp>
#include <JUI/Widgets/ListLayout.hpp>
#include <JUI/Widgets/TextButton.hpp>

namespace CaveGame::Client
{
    using namespace JUI::UDimLiterals;

    class PauseMenuWidget : public JUI::Rect {
    public:
          Event<> OnSettingsButtonPressed;
          Event<> OnQuitButtonPressed;

          PauseMenuWidget() {
              this->Size({100_percent, 100_percent}); // Full Screen.
              this->BGColor({128, 128, 128, 128});    // Transparent Gray.

              button_box = new JUI::Rect(this);
              button_box->Size({150_px, 150_px});

              button_list = new JUI::VerticalListLayout(button_box);

              resume_btn = new JUI::TextButton(button_list);
              resume_btn->SetContent("Resume");


              settings_btn = new JUI::TextButton(button_list);
              settings_btn->SetContent("Settings");

              quit_btn = new JUI::TextButton(button_list);
              quit_btn->SetContent("Save & Exit World");
          }

          explicit PauseMenuWidget(Widget* parent) : PauseMenuWidget() {
              this->Parent(parent);
          }

          void Toggle() {
              is_open = !is_open;
              this->Visible(is_open);
          }
    protected:
        JUI::Rect* button_box;
        JUI::VerticalListLayout* button_list;
        JUI::TextButton* resume_btn;
        JUI::TextButton* settings_btn;
        JUI::TextButton* quit_btn;

        bool is_open;
    private:
    };


}